## ros-rolling-behaviortree-cpp-v3 3.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1) # version on Ubuntu Xenial
project(behaviortree_cpp_v3)

#---- Add the subdirectory cmake ----
set(CMAKE_CONFIG_PATH ${CMAKE_MODULE_PATH}  "${CMAKE_CURRENT_LIST_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CONFIG_PATH}")

#---- Enable C++14 ----
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
else()
    add_definitions(-Wpedantic)
endif()

#---- Include boost to add coroutines ----
find_package(Boost COMPONENTS coroutine QUIET)

if(Boost_FOUND)
    string(REPLACE "." "0" Boost_VERSION_NODOT ${Boost_VERSION})
    if(NOT Boost_VERSION_NODOT VERSION_LESS 105900)
        message(STATUS "Found boost::coroutine2.")
        add_definitions(-DBT_BOOST_COROUTINE2)
        set(BT_COROUTINES true)
    elseif(NOT Boost_VERSION_NODOT VERSION_LESS 105300)
        message(STATUS "Found boost::coroutine.")
        add_definitions(-DBT_BOOST_COROUTINE)
        set(BT_COROUTINES true)
    endif()
    include_directories(${Boost_INCLUDE_DIRS})
endif()


if(NOT DEFINED BT_COROUTINES)
    message(STATUS "Coroutines disabled. Install Boost to enable them (version 1.59+ recommended).")
    add_definitions(-DBT_NO_COROUTINES)
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

#---- project configuration ----
option(BUILD_EXAMPLES   "Build tutorials and examples" ON)
option(BUILD_UNIT_TESTS "Build the unit tests" ON)
option(BUILD_TOOLS "Build commandline tools" ON)
option(BUILD_SHARED_LIBS "Build shared libraries" ON)

#---- Find other packages ----
find_package(Threads)
find_package(ZMQ)

list(APPEND BEHAVIOR_TREE_PUBLIC_LIBRARIES
    ${CMAKE_THREAD_LIBS_INIT}
    ${CMAKE_DL_LIBS}
)

if( ZMQ_FOUND )
    message(STATUS "ZeroMQ found.")
    add_definitions( -DZMQ_FOUND )
    list(APPEND BT_SOURCE src/loggers/bt_zmq_publisher.cpp)
else()
    message(WARNING "ZeroMQ NOT found. Skipping the build of [PublisherZMQ] and [bt_recorder].")
endif()

set(BEHAVIOR_TREE_LIBRARY ${PROJECT_NAME})

# Update the policy setting to avoid an error when loading the ament_cmake package
# at the current cmake version level
if(POLICY CMP0057)
    cmake_policy(SET CMP0057 NEW)
endif()

find_package(ament_cmake QUIET)

if ( ament_cmake_FOUND )

    # Not adding -DUSING_ROS since xml_parsing.cpp hasn't been ported to ROS2

    message(STATUS "------------------------------------------")
    message(STATUS "BehaviourTree is being built using AMENT.")
    message(STATUS "------------------------------------------")

    set(BUILD_TOOL_INCLUDE_DIRS ${ament_INCLUDE_DIRS})

elseif( CATKIN_DEVEL_PREFIX OR CATKIN_BUILD_BINARY_PACKAGE)

    set(catkin_FOUND 1)
    add_definitions( -DUSING_ROS )
    find_package(catkin REQUIRED COMPONENTS roslib)
    find_package(GTest)

    message(STATUS "------------------------------------------")
    message(STATUS "BehaviourTree is being built using CATKIN.")
    message(STATUS "------------------------------------------")

    catkin_package(
        INCLUDE_DIRS include # do not include "3rdparty" here
        LIBRARIES ${BEHAVIOR_TREE_LIBRARY}
        CATKIN_DEPENDS roslib
        )

    list(APPEND BEHAVIOR_TREE_PUBLIC_LIBRARIES ${catkin_LIBRARIES})
    set(BUILD_TOOL_INCLUDE_DIRS ${catkin_INCLUDE_DIRS})

elseif(BUILD_UNIT_TESTS)
    find_package(GTest REQUIRED)
endif()


#############################################################
if(ament_cmake_FOUND)
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )

    ament_export_include_directories(include)
    ament_export_libraries(${BEHAVIOR_TREE_LIBRARY})
    ament_package()
elseif(catkin_FOUND)
    set( BEHAVIOR_TREE_LIB_DESTINATION   ${CATKIN_PACKAGE_LIB_DESTINATION} )
    set( BEHAVIOR_TREE_INC_DESTINATION   ${CATKIN_GLOBAL_INCLUDE_DESTINATION} )
    set( BEHAVIOR_TREE_BIN_DESTINATION   ${CATKIN_GLOBAL_BIN_DESTINATION} )
else()
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )

    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${BEHAVIOR_TREE_BIN_DESTINATION}" )
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${BEHAVIOR_TREE_LIB_DESTINATION}" )
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${BEHAVIOR_TREE_BIN_DESTINATION}" )
endif()

message( STATUS "BEHAVIOR_TREE_LIB_DESTINATION:   ${BEHAVIOR_TREE_LIB_DESTINATION} " )
message( STATUS "BEHAVIOR_TREE_BIN_DESTINATION:   ${BEHAVIOR_TREE_BIN_DESTINATION} " )
message( STATUS "CMAKE_RUNTIME_OUTPUT_DIRECTORY:  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY} " )
message( STATUS "CMAKE_LIBRARY_OUTPUT_DIRECTORY:  ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} " )
message( STATUS "CMAKE_ARCHIVE_OUTPUT_DIRECTORY:  ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY} " )

#############################################################
# LIBRARY

list(APPEND BT_SOURCE
    src/action_node.cpp
    src/basic_types.cpp
    src/behavior_tree.cpp
    src/blackboard.cpp
    src/bt_factory.cpp
    src/decorator_node.cpp
    src/condition_node.cpp
    src/control_node.cpp
    src/shared_library.cpp
    src/tree_node.cpp
    src/xml_parsing.cpp

    src/decorators/inverter_node.cpp
    src/decorators/repeat_node.cpp
    src/decorators/retry_node.cpp
    src/decorators/subtree_node.cpp
    src/decorators/delay_node.cpp

    src/controls/if_then_else_node.cpp
    src/controls/fallback_node.cpp
    src/controls/parallel_node.cpp
    src/controls/reactive_sequence.cpp
    src/controls/reactive_fallback.cpp
    src/controls/sequence_node.cpp
    src/controls/sequence_star_node.cpp
    src/controls/switch_node.cpp
    src/controls/while_do_else_node.cpp

    src/loggers/bt_cout_logger.cpp
    src/loggers/bt_file_logger.cpp
    src/loggers/bt_minitrace_logger.cpp
    src/private/tinyxml2.cpp

    3rdparty/minitrace/minitrace.cpp
    )

find_package(Curses QUIET)

if(CURSES_FOUND)
    list(APPEND BT_SOURCE
        src/controls/manual_node.cpp
        )
    list(APPEND BEHAVIOR_TREE_PUBLIC_LIBRARIES ${CURSES_LIBRARIES})
    add_definitions(-DNCURSES_FOUND)
endif()


######################################################

if (UNIX)
    list(APPEND BT_SOURCE src/shared_library_UNIX.cpp )
    if (BUILD_SHARED_LIBS)
        add_library(${BEHAVIOR_TREE_LIBRARY} SHARED ${BT_SOURCE})
    else()
        add_library(${BEHAVIOR_TREE_LIBRARY} STATIC ${BT_SOURCE})
    endif()
endif()

if (WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
    list(APPEND BT_SOURCE src/shared_library_WIN.cpp )
    add_library(${BEHAVIOR_TREE_LIBRARY} STATIC ${BT_SOURCE} )
endif()

if( ZMQ_FOUND )
    list(APPEND BUILD_TOOL_INCLUDE_DIRS ${ZMQ_INCLUDE_DIRS})
endif()

target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PUBLIC
    ${BEHAVIOR_TREE_PUBLIC_LIBRARIES})

target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PRIVATE
    ${Boost_LIBRARIES}
    ${ZMQ_LIBRARIES})

#get_target_property(my_libs ${BEHAVIOR_TREE_LIBRARY} INTERFACE_LINK_LIBRARIES)
#list(REMOVE_ITEM _libs X)
#message("my_libs: ${my_libs}")

#set_target_properties(${BEHAVIOR_TREE_LIBRARY} PROPERTIES INTERFACE_LINK_LIBRARIES "")

target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PRIVATE $<$<CONFIG:Debug>:TINYXML2_DEBUG>)

target_include_directories(${BEHAVIOR_TREE_LIBRARY} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    ${BUILD_TOOL_INCLUDE_DIRS})

if( ZMQ_FOUND )
    target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PUBLIC ZMQ_FOUND)
endif()

if(MSVC)
else()
    target_compile_options(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        -Wall -Wextra -Werror=return-type)
endif()

######################################################
# Samples
if (BUILD_SAMPLES)
    add_subdirectory(sample_nodes)
endif()

######################################################
# Test
if (BUILD_UNIT_TESTS AND BUILD_SAMPLES)
    add_subdirectory(tests)
endif()

######################################################
# INSTALL

INSTALL(TARGETS ${BEHAVIOR_TREE_LIBRARY}
    EXPORT BehaviorTreeV3Config
    ARCHIVE DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
    LIBRARY DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
    RUNTIME DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION}
    )

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/
    DESTINATION ${BEHAVIOR_TREE_INC_DESTINATION}
    FILES_MATCHING PATTERN "*.h*")

install(EXPORT BehaviorTreeV3Config
    DESTINATION "${BEHAVIOR_TREE_LIB_DESTINATION}/BehaviorTreeV3/cmake"
    NAMESPACE BT::)

export(TARGETS ${PROJECT_NAME}
    NAMESPACE BT::
    FILE "${CMAKE_CURRENT_BINARY_DIR}/BehaviorTreeV3Config.cmake")

export(PACKAGE ${PROJECT_NAME})

######################################################
# EXAMPLES and TOOLS
if(BUILD_TOOLS)
    add_subdirectory(tools)
endif()

if(BUILD_EXAMPLES AND BUILD_SAMPLES)
    add_subdirectory(examples)
endif()

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)

include_directories( ../sample_nodes )

set(CMAKE_DEBUG_POSTFIX "")

# The plugin libdummy_nodes.so can be linked statically or
# loaded dynamically at run-time.
add_executable(t01_first_tree_static  t01_build_your_first_tree.cpp )
target_compile_definitions(t01_first_tree_static PRIVATE "MANUAL_STATIC_LINKING")
target_link_libraries(t01_first_tree_static ${BEHAVIOR_TREE_LIBRARY}   bt_sample_nodes )

add_executable(t01_first_tree_dynamic  t01_build_your_first_tree.cpp )
target_link_libraries(t01_first_tree_dynamic ${BEHAVIOR_TREE_LIBRARY}  )


add_executable(t02_basic_ports  t02_basic_ports.cpp )
target_link_libraries(t02_basic_ports ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )

add_executable(t03_generic_ports        t03_generic_ports.cpp )
target_link_libraries(t03_generic_ports ${BEHAVIOR_TREE_LIBRARY}  bt_sample_nodes  )

add_executable(t04_reactive_sequence         t04_reactive_sequence.cpp )
target_link_libraries(t04_reactive_sequence  ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes  )

add_executable(t05_cross_door         t05_crossdoor.cpp )
target_link_libraries(t05_cross_door   ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )

add_executable(t06_subtree_port_remapping  t06_subtree_port_remapping.cpp )
target_link_libraries(t06_subtree_port_remapping ${BEHAVIOR_TREE_LIBRARY}   bt_sample_nodes )

add_executable(t07_wrap_legacy         t07_wrap_legacy.cpp )
target_link_libraries(t07_wrap_legacy   ${BEHAVIOR_TREE_LIBRARY} )

add_executable(t08_additional_node_args   t08_additional_node_args.cpp )
target_link_libraries(t08_additional_node_args   ${BEHAVIOR_TREE_LIBRARY} )

if (BT_COROUTINES)
    add_executable(t09_async_actions_coroutines  t09_async_actions_coroutines.cpp )
    target_link_libraries(t09_async_actions_coroutines ${BEHAVIOR_TREE_LIBRARY} )
endif()

add_executable(t10_include_trees  t10_include_trees.cpp )
target_link_libraries(t10_include_trees  ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )


add_executable(t11_runtime_ports  t11_runtime_ports.cpp )
target_link_libraries(t11_runtime_ports  ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )

if(CURSES_FOUND)
    add_executable(t12_ncurses_manual_selector  t12_ncurses_manual_selector.cpp )
    target_link_libraries(t12_ncurses_manual_selector  ${BEHAVIOR_TREE_LIBRARY} bt_sample_nodes )
endif()


add_executable(increment  increment.cpp )
target_link_libraries(increment ${BEHAVIOR_TREE_LIBRARY}  )

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)


add_executable(bt3_log_cat         bt_log_cat.cpp )
target_link_libraries(bt3_log_cat  ${BEHAVIOR_TREE_LIBRARY} )
install(TARGETS bt3_log_cat
        DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )

if( ZMQ_FOUND )
    add_executable(bt3_recorder         bt_recorder.cpp )
    target_link_libraries(bt3_recorder  ${BEHAVIOR_TREE_LIBRARY} ${ZMQ_LIBRARIES})
    install(TARGETS bt3_recorder
            DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )
endif()

add_executable(bt3_plugin_manifest         bt_plugin_manifest.cpp )
target_link_libraries(bt3_plugin_manifest  ${BEHAVIOR_TREE_LIBRARY} )
install(TARGETS bt3_plugin_manifest
        DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )

=== debian/changelog ===
ros-rolling-behaviortree-cpp-v3 (3.6.0-1focal) focal; urgency=high

  * Build samples independently of examples (#315 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/315>)
  * Fix dependency in package.xml (#313 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/313>)
  * Fix doc statement (#309 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/309>)
    Fix sentence
  * Fix references to RetryUntilSuccesful (#308 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/308>)
    * Fix github action
    * Fix references to RetryUntilSuccesful
  * added subclass RetryNodeTypo (#295 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/295>)
    Co-authored-by: Subaru Arai <mailto:SubaruArai@local>
  * Fix github action (#302 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/302>)
  * Minor spelling correction (#305 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/305>)
    Corrected the_aswer to the_answer
  * Update FallbackNode.md (#306 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/306>)
    typo correction.
  * Add signal handler for Windows (#307 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/307>)
  * fix
  * file renamed and documentation fixed
  * Update documentation for reactive sequence (#286 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/286>)
  * Update FallbackNode.md (#287 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/287>)
    Fix the pseudocode in the documentation of 'Reactive Fallback' according to its source code.
  * Update fallback documentation to V3 (#288 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/288>)
    * Update FallbackNode.md description to V3
    * Fix typo
  * Use pedantic for non MSVC builds (#289 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/289>)
  * Merge branch 'master' of https://github.com/BehaviorTree/BehaviorTree.CPP
  * updated to latest flatbuffers
  * Update README.md
  * Fix issue #273 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/273>
  * remove potential crash when an unfinished tree throws an exception
  * remove appveyor
  * Merge branch 'git_actions'
  * Fixes for compilation on windows. (#248 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/248>)
    * Fix for detecting ZeroMQ on windows
    Naming convention is a bit different for ZeroMQ, specifically on Windows with vcpkg. While ZMQ and ZeroMQ are valid on linux, the ZMQ naming convention only works on linux.
    * Compilation on windows not working with /WX
    * Macro collision on Windows
    On windows, the macros defined in the abstract logger collides with other in windows.h. Made them lowercase to avoid collision
  * Remove native support for Conan (#280 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/280>)
  * add github workflow
  * Registered missing dummy nodes for examples (#275 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/275>)
    * Added CheckTemperature dummy node
    * Added SayHello dummy node
  * add zmq.hpp in 3rdparty dirfectory
  * add test
  * fix some warnings
  * Fix bug on halt of delay node (#272 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/272>)
    - When DelayNode is halted and ticked again, it always returned FAILURE since the state of DelayNode was not properly reset.
    - This commit fixes unexpected behavior of DelayNode when it is halted.
    Co-authored-by: Jinwoo Choi <mailto:jinwoos.choi@samsung.com>
  * Clear all of blackboard's content (#269 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/269>)
  * Added printTreeRecursively overload with ostream parameter (#264 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/264>)
    * Added overload to printTreeRecursively
    * Changed include to iosfwd
    * Added test to verify function writes to stream
    * Added call to overload without stream parameter
    * Fixed conversion error
    * Removed overload in favor of default argument
  * Fix typo (#260 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/260>)
    Co-authored-by: Francesco Vigni <mailto:francesco.vigni@sttech.de>
  * Update README.md
  * abstract_logger.h: fixed a typo (#257 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/257>)
  * Contributors: Adam Sasine, Affonso, Guilherme, Akash, Billy, Cong Liu, Daisuke Nishimatsu, Davide Faconti, Francesco Vigni, Heben, Jake Keller, Per-Arne Andersen, Ross Weir, Steve Macenski, SubaruArai, Taehyeon, Uilian Ries, Yadu, Yuwei Liang, matthews-jca, swarajpeppermint

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 09 Nov 2021 23:00:00 -0000

ros-rolling-behaviortree-cpp-v3 (3.5.6-1focal) focal; urgency=high

  * fix issue #227 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/227>
  * fix issue #256 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/256>
  * Merge branch 'master' of https://github.com/BehaviorTree/BehaviorTree.CPP
  * fix issue #250 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/250>
  * Fixed typos on SequenceNode.md (#254 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/254>)
  * Contributors: Davide Faconti, LucasNolasco

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 02 Feb 2021 23:00:00 -0000

ros-rolling-behaviortree-cpp-v3 (3.5.5-1focal) focal; urgency=high

  * fix issue #251 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/251>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 26 Jan 2021 23:00:00 -0000

ros-rolling-behaviortree-cpp-v3 (3.5.4-1focal) focal; urgency=high

  * Update bt_factory.cpp (#245 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/245>)
  * Use the latest version of zmq.hpp
  * Improved switching BTs with active Groot monitoring (ZMQ logger destruction) (#244 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/244>)
    * Skip 100ms (max) wait for detached thread
    * add {} to single line if statements
  * Update retry_node.cpp
  * fix


=== debian/control ===
Source: ros-rolling-behaviortree-cpp-v3
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libncurses5-dev, libzmq3-dev, ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest, ros-rolling-rclcpp, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-behaviortree-cpp-v3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libncurses5-dev, libzmq3-dev, ros-rolling-rclcpp, ros-rolling-ros-workspace
Description: This package provides the Behavior Trees core library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-behaviortree-cpp-v3//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-behaviortree-cpp-v3 3.8.4

=== debian/changelog ===
ros-rolling-behaviortree-cpp-v3 (3.8.4-1jammy) jammy; urgency=high

  * Update ros2.yaml
  * Update ros1.yaml
  * Issue 563 (#596 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/596>)
    * failing test
    * fix issue 563 (?)
    * better solution
  * use lambda in tutorial
  * Merge pull request #583 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/583> from BehaviorTree/issue563
    Issue563
  * better default port
  * restore type check
  * fix issue #563 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/563>
  * fix test
  * Issue563
  * Merge pull request #579 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/579> from open-navigation/hi
    changing resetStatus to public
  * Update tree_node.h
  * changing resetStatus to public
  * Merge branch 'v3.8' of github.com:BehaviorTree/BehaviorTree.CPP into v3.8
  * backporting fixes from branch 4.x
  * Merge pull request #546 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/546> from divbyzerofordummies/fix_ROS_include
    Fix issue #545 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/545>
  * Fix issue #545 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/545>
  * bug fix: halting a Node must invoke the Loggers
  * unit test added
  * Contributors: Daniel Muschick, Davide Faconti, Steve Macenski, stevemacenski

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 27 Jun 2023 22:00:00 -0000

ros-rolling-behaviortree-cpp-v3 (3.8.3-1jammy) jammy; urgency=high

  * fix and warnings added
  * fix in SharedLibrary and cosmetic changes to the code
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 28 Feb 2023 23:00:00 -0000

ros-rolling-behaviortree-cpp-v3 (3.8.2-1jammy) jammy; urgency=high

  * rebane haltChildren to resetChildren
  * revert #329 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/329>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 04 Jan 2023 23:00:00 -0000

ros-rolling-behaviortree-cpp-v3 (3.8.1-1jammy) jammy; urgency=high

  * fix catkin installation #478 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/478>
  * cherry picking changes from v4
  * fix #227 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/227>
  * fix issue #461 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/461>
  * fix issue #413 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/413> (Delay logic)
  * Update README.md
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 26 Nov 2022 23:00:00 -0000

ros-rolling-behaviortree-cpp-v3 (3.8.0-1jammy) jammy; urgency=high

  * tickRootWhileRunning method
  * Fix: PublisherZMQ::flush is called after the publisher has been destructed (#426 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/426>)
    * fix: PublisherZMQ::flush is called after the publisher has been destructed
    * style: Adjust code formatting of ~PublisherZMQ
    * chore: Install zmq-dev in ubuntu pipeline and exclude gtest_logger_zmq.cpp when zmq is not found.
    * chore: Define WIN32_LEAN_AND_MEAN to avoid ambiguity between tinyxml and msxml
  * fix missing closing brace in unit test (#442 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/442>)
  * Fix incorrect registration of behavior trees containing faulty XML (#438 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/438>)
    * fix incorrect registration of faulty trees
    * format
    * simplify XML validation
    * fix possible out-of-range exception in tests
    * Add tests
    * reduce scale of diffs
    * fix comment
    * add more test cases
    Co-authored-by: Davide Faconti <mailto:davide.faconti@gmail.com>
  * Add functionality to clear registered behavior trees. (#439 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/439>)
    Co-authored-by: Jere Liukkonen <mailto:jere@picknik.ai>
  * Wait for the thread to finish before deleting zmq (#440 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/440>)
    Co-authored-by: JafarAbdi <mailto:cafer.abdi@gmail.com>
  * clang form at
  * clang format
  * new clang format
  * Moving tinyxml2 to 3rdparty
  * Merge branch 'master' of github.com:BehaviorTree/BehaviorTree.CPP
  * backporting changes from v4.x
  * Update README.md
  * fix warnings
  * Merge branch 'master' of github.com:BehaviorTree/BehaviorTree.CPP
  * fix issue #433 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/433>
  * Added ros_environment dependency to make sure ROS_VERSION is initialized (#420 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/420>)
  * Added XML validation for decorators without children (#424 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/424>)
    * Added unit tests to demonstrate failure
    * Added validation that decorators have only one child
  * Update expected-lite to 0.6.2 (#418 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/418>)
  * fix test
  * parallel node fix
  * threshold child count dynamically in parallel control node (#363 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/363>)
  * Adding the reserved word "_description" (#394 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/394>)
  * fix(README): change find_package() instruction for BT external usage (#401 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/401>)
    Co-authored-by: Luca Bonamini <mailto:luca.bonamini@yapemobility.it>
  * Example suggests it's not restricted to a few (#414 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/414>)
    * Example suggests it's not restricted to a few
    * Update delay_node.h
    Fix flow of sentence, milliseconds is already put in specification.
  * documentation and doc correction
  * Merge branch 'master' of github.com:BehaviorTree/BehaviorTree.CPP
  * improve writeTreeNodesModelXML
  * Shutdown zmq context after joining the server thread and flushing (#400 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/400>)
  * Update README.md


=== debian/control ===
Source: ros-rolling-behaviortree-cpp-v3
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libncurses5-dev, libzmq3-dev, ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-index-cpp, ros-rolling-rclcpp, ros-rolling-ros-environment, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-behaviortree-cpp-v3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libncurses5-dev, libzmq3-dev, ros-rolling-ament-index-cpp, ros-rolling-rclcpp, ros-rolling-ros-workspace
Description: This package provides the Behavior Trees core library.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
